unit dsunzip;

/// NOT THREAD-SAFE!!!!!!!!!!!!!!!!!

interface
uses Classes;

type
  TUnzip = class
  private
    FFiles: TStringList;
    FFilename: String;
    function GetFiles: TStrings;
  public
    constructor Create(const Filename: String);
    destructor Destroy; override;
    property Files: TStrings read GetFiles;
    property Filename: String read FFilename;
  end;


implementation
uses Unzip, ZipTypes;
{ TUnzip }

constructor TUnzip.Create(const Filename: String);
begin
  inherited Create;
  FFilename:=Filename;
end;

destructor TUnzip.Destroy;
begin
  FFiles.Free;
  inherited Destroy;
end;


var
  CurrentObj: TUnzip;

procedure ViewReport (Retcode: Longint; Rec : PReportRec); stdcall;
begin
  with CurrentObj do
  begin
    Files.Add(Rec^.FileName);
  end;
end;

function TUnzip.GetFiles: TStrings;
begin
  if FFiles = nil then
  begin
    FFiles:=TStringList.Create;
    CurrentObj:=Self;
    ViewZip(PChar(FFilename), '*.*', ViewReport);
  end;
  Result:=FFiles;
end;

end.
